<?php


namespace Controller;

use Traits\TResponse;
use Zeedhi\Framework\DTO\Request;
use Service\DocumentsTemplate as DocumentsTemplateService;
use Util\InstanceProvider;


class DocumentsTemplate
{
    use TResponse;
    private $documentsTemplateService;

    public function __construct(DocumentsTemplateService $documentsTemplateService)
    {
        $this->documentsTemplateService = $documentsTemplateService;
    }

    public function findDocumentsTemplate(Request $request) {
        try {
            $data = $this->documentsTemplateService->findDocumentsTemplate();
            $this->sendResponse($data, 200);
        } catch(\Exception $ex){
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveDocumentTemplate(Request $request)
    {
        try {
            $row = $request->getParameters();
            if(!empty($row['DOCUMENT'])){
                InstanceProvider::getFileUploaderServe()->uploadFilesInRow($row, 'DOCUMENT', 'PmDevOps/DocumentTemplate');
            }
            $documentTemplateId = empty($row['ID']) ? null : $row['ID'];
            $name = $row['NAME'];
            $type = $row['TYPE'];
            $document = empty($row['DOCUMENT']) ? null : $row['DOCUMENT'];
            
            $documentTemplateId = $this->documentsTemplateService->saveDocumentTemplate($documentTemplateId, $name, $type, $document);
            $this->sendResponse($documentTemplateId, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);

        }

    }

   
}
