CREATE OR REPLACE
PROCEDURE IMP_AUTOFORNE_NGD
IS
  V_ERRO         VARCHAR2(300);
  V_IDPESQITEM   VARCHAR2(300);
  V_CONTADOR     FLOAT;
  V_CDCOMRADOR   OPERADOR.CDOPERADOR%TYPE;
  V_NRAUTOFORN   VARCHAR2(20);
  V_CDEMPRESA    EMPRESA.CDEMPRESA%TYPE;
  V_EMITENTE     VARCHAR2(4);
  V_CDMARCA      MARCA.CDMARCA%TYPE;
  V_VRPREUNIAF   ITEMAUTF.VRPREUNIAF%TYPE;
  V_CDINSCESTA   ALIQUOTA.CDINSCESTA%TYPE;
  V_CDFORNECED   FORNECEDOR.CDFORNECED%TYPE;
  V_CONTAAF      NUMERIC;
  V_CDMARCA_PADRAO FLOAT;
  V_NRSEQENVIOAFORN VARCHAR2(20) := '';
BEGIN
   FOR C_AUTOFORNE IN (SELECT USR_AUTOFORNE_NGD.USR_NRPEDIDO, USR_AUTOFORNE_NGD.CDFILIOPELOG, USR_AUTOFORNE_NGD.CDFORNECED,
                              MAX(USR_AUTOFORNE_NGD.CDARVPROD) CDARVPROD, USR_AUTOFORNE_NGD.DTPROGENTAF, FILIAL.CDREGIAO, FORNECEDOR.CDFORMPGTO,
                              FORNECEDOR.IDTPFORPGTFO, FORNECEDOR.IDTPFRETFORN, FORNECEDOR.NRPARCPGTOFO, FORNECEDOR.NRDIAPGFIXFO,
                              FORNECEDOR.CDTIPCOB, FORNECEDOR.CDTPCTPAGAR, FORNECEDOR.IDUTDIAPGTFO, USR_AUTOFORNE_NGD.DTPROGENTAF DTPROGENTAF_NGD,
                              LISTAGG(RELACPRODOL.CDPRARVORIG||RELACPRODOL.CDMARCA, '_') WITHIN GROUP (ORDER BY RELACPRODOL.CDPRARVORIG||RELACPRODOL.CDMARCA) LISTA_CDPRARVORIG
                         FROM USR_AUTOFORNE_NGD, FILIAL, FORNECEDOR, RELACPRODOL, PRODUTO PRODUTOOL
                        WHERE USR_AUTOFORNE_NGD.CDFILIOPELOG = FILIAL.CDFILIAL
                          AND USR_AUTOFORNE_NGD.CDFORNECED     = FORNECEDOR.CDFORNECED
                          AND USR_AUTOFORNE_NGD.STATUS IN ('1', '3')
                          AND USR_AUTOFORNE_NGD.IDSTATUSAF     = 'ATIVO'
                          AND NVL(FILIAL.IDCNTRRESC, 'N') <> 'S'
                          AND NVL(FILIAL.IDFUNCAOFILI, 'T') = 'O'
                          AND USR_AUTOFORNE_NGD.CDARVPROD      = PRODUTOOL.CDARVPROD
                          AND RELACPRODOL.CDPRODARVOL          = PRODUTOOL.CDPRODUTO
                          AND USR_AUTOFORNE_NGD.CDFILIOPELOG NOT IN ('0003', '1010', '3801', '3802', '9793', '9891', 'C106')
                        GROUP BY USR_AUTOFORNE_NGD.USR_NRPEDIDO, USR_AUTOFORNE_NGD.CDFILIOPELOG, USR_AUTOFORNE_NGD.CDFORNECED,
                              USR_AUTOFORNE_NGD.DTPROGENTAF, FILIAL.CDREGIAO, FORNECEDOR.CDFORMPGTO,
                              FORNECEDOR.IDTPFORPGTFO, FORNECEDOR.IDTPFRETFORN, FORNECEDOR.NRPARCPGTOFO, FORNECEDOR.NRDIAPGFIXFO,
                              FORNECEDOR.CDTIPCOB, FORNECEDOR.CDTPCTPAGAR, FORNECEDOR.IDUTDIAPGTFO, USR_AUTOFORNE_NGD.DTPROGENTAF
                        ORDER BY USR_AUTOFORNE_NGD.USR_NRPEDIDO, USR_AUTOFORNE_NGD.CDFILIOPELOG)
   LOOP
      SELECT NVL(MIN(ITEMCOLE.CDFORNECED), '')
        INTO V_CDFORNECED
        FROM ITEMCOLE
       WHERE ITEMCOLE.CDREGIAO   = C_AUTOFORNE.CDREGIAO
         AND INSTR('_'||C_AUTOFORNE.LISTA_CDPRARVORIG||'_', ITEMCOLE.CDPRODUTO||ITEMCOLE.CDMARCA) > 0
         AND C_AUTOFORNE.DTPROGENTAF BETWEEN TO_CHAR(DTINIVALITM, 'YYYYMMDD') AND TO_CHAR(DTFINVALITM, 'YYYYMMDD')
         AND NVL(VRPRECUNIITM, 0) > 0;
      IF V_CDFORNECED = '' THEN
         SELECT NVL(MIN(ITEMCOLE.CDFORNECED), '')
           INTO V_CDFORNECED
           FROM ITEMCOLE
          WHERE ITEMCOLE.CDREGIAO   = C_AUTOFORNE.CDREGIAO
            AND INSTR('_'||C_AUTOFORNE.LISTA_CDPRARVORIG||'_', ITEMCOLE.CDPRODUTO) > 0
            AND C_AUTOFORNE.DTPROGENTAF BETWEEN TO_CHAR(DTINIVALITM, 'YYYYMMDD') AND TO_CHAR(DTFINVALITM, 'YYYYMMDD')
            AND NVL(VRPRECUNIITM, 0) > 0;
      END IF;
      V_IDPESQITEM := C_AUTOFORNE.USR_NRPEDIDO||'-'||C_AUTOFORNE.CDFILIOPELOG||'-'||C_AUTOFORNE.CDFORNECED||'-'||
                      C_AUTOFORNE.CDARVPROD||'-'||C_AUTOFORNE.DTPROGENTAF_NGD;
      IF V_CDFORNECED <> '' THEN
         V_ERRO     := NULL;
         V_CONTADOR := 0;
         V_IDPESQITEM := C_AUTOFORNE.USR_NRPEDIDO||'-'||C_AUTOFORNE.CDFILIOPELOG||'-'||C_AUTOFORNE.CDFORNECED||'-'||
                         C_AUTOFORNE.CDARVPROD||'-'||C_AUTOFORNE.DTPROGENTAF_NGD;
         UPDATE USR_AUTOFORNE_NGD
            SET STATUS = '3',
                DTINTERFACEDEST = SYSDATE
          WHERE USR_NRPEDIDO    = C_AUTOFORNE.USR_NRPEDIDO
            AND CDFILIOPELOG    = C_AUTOFORNE.CDFILIOPELOG
            AND CDFORNECED      = C_AUTOFORNE.CDFORNECED
            AND DTPROGENTAF     = C_AUTOFORNE.DTPROGENTAF_NGD;
         COMMIT;
         BEGIN
            NOVO_CODIGO_NT('AUTOFORNE', V_NRAUTOFORN, 1);
            V_NRAUTOFORN := SUBSTR(V_NRAUTOFORN, 11, 10);
            INSERT
              INTO AUTOFORNE (CDFILDEST,    CDFILLANC,    NRAUTOFORN, IDTPFORPGTAF,
                   IDTIPOFRETAF, NRPARCPGTOAF, NRDIAPGFIXAF, IDUTDIAPGTAF,
                   CDTIPCOB,    CDFORMPGTO,   CDFORNECED, IDTIPOLANCAF,
                   IDAFCONS, CDTPCTPAGAR, IDAUTOFORNEX, CDOPERADOR, DTAUTOFORN, IDTIPOEMITAF, USR_NRPEDIDO_NGD)
            VALUES (C_AUTOFORNE.CDFILIOPELOG, '0003', V_NRAUTOFORN, C_AUTOFORNE.IDTPFORPGTFO,
                    C_AUTOFORNE.IDTPFRETFORN, C_AUTOFORNE.NRPARCPGTOFO, C_AUTOFORNE.NRDIAPGFIXFO, C_AUTOFORNE.IDUTDIAPGTFO,
                    C_AUTOFORNE.CDTIPCOB, C_AUTOFORNE.CDFORMPGTO, V_CDFORNECED, 'A',
                    'N',  C_AUTOFORNE.CDTPCTPAGAR, 'N', '000000000065', SYSDATE, '1', C_AUTOFORNE.USR_NRPEDIDO);
            INSERT
              INTO PRAZOPGTAF (CDFILDEST, CDFILLANC, NRAUTOFORN, NRDIASPGTOAF, VRPERCPGTOAF)
            SELECT C_AUTOFORNE.CDFILIOPELOG, '0003', V_NRAUTOFORN, NRDIASPGTOFO, VRPERCPGTOFO
              FROM PRAZOPGTFORN
             WHERE CDFORNECED = V_CDFORNECED;
         EXCEPTION
            WHEN OTHERS THEN BEGIN
               ROLLBACK;
               V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
               UPDATE USR_LOG_NGD
                  SET DTLOG      = SYSDATE,
                      STATUS     = '1',
                      OBSSTATUS  = V_ERRO
                WHERE IDPROCESSO = 'USR_AUTOFORNE_NGD'
                  AND IDPESQITEM = V_IDPESQITEM;
               IF SQL%NOTFOUND THEN
                  INSERT
                    INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                  VALUES ('USR_AUTOFORNE_NGD', SYSDATE, '1', V_ERRO, V_IDPESQITEM);
               END IF;
               COMMIT;
            END;
         END;
         IF V_ERRO IS NULL THEN
            FOR C_ITEMAUTF IN
               (SELECT USR_AUTOFORNE_NGD.USR_NRPEDIDO, USR_AUTOFORNE_NGD.CDFILIOPELOG, USR_AUTOFORNE_NGD.CDARVPROD,
                       TO_DATE(SUBSTR(USR_AUTOFORNE_NGD.DTPROGENTAF, 7, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTPROGENTAF, 5, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTPROGENTAF, 1, 4), 'DD/MM/YYYY') DTPROGENTAF,
                       USR_AUTOFORNE_NGD.QTPROGENTAF, USR_AUTOFORNE_NGD.VRPREUNIAF, USR_AUTOFORNE_NGD.CDFORNECED, USR_AUTOFORNE_NGD.TXOBSITMAF,
                       TO_DATE(SUBSTR(USR_AUTOFORNE_NGD.DTOPERACAO, 7, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTOPERACAO, 5, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTOPERACAO, 1, 4), 'DD/MM/YYYY') DTOPERACAO,
                       C_AUTOFORNE.CDREGIAO CDREGIAO, USR_AUTOFORNE_NGD.DTPROGENTAF DTPROGENTAF_NGD, RELACPRODOL.CDPRARVORIG, RELACPRODOL.CDPRODARVOL,
                       LISTAGG(RELACPRODOL.CDPRARVORIG, '_') WITHIN GROUP (ORDER BY RELACPRODOL.CDPRARVORIG) LISTA_CDPRARVORIG
                  FROM USR_AUTOFORNE_NGD, RELACPRODOL, PRODUTO PRODUTOOL
                 WHERE USR_AUTOFORNE_NGD.USR_NRPEDIDO   = C_AUTOFORNE.USR_NRPEDIDO
                   AND USR_AUTOFORNE_NGD.CDFILIOPELOG   = C_AUTOFORNE.CDFILIOPELOG
                   AND USR_AUTOFORNE_NGD.IDSTATUSAF     = 'ATIVO'
                   AND USR_AUTOFORNE_NGD.STATUS         IN ('1', '3')
                   AND USR_AUTOFORNE_NGD.CDARVPROD      = PRODUTOOL.CDARVPROD
                   AND RELACPRODOL.CDPRODARVOL          = PRODUTOOL.CDPRODUTO
                   AND USR_AUTOFORNE_NGD.CDFILIOPELOG NOT IN ('0003', '1010', '3801', '3802', '9793', '9891', 'C106')
                 GROUP BY USR_AUTOFORNE_NGD.USR_NRPEDIDO, USR_AUTOFORNE_NGD.CDFILIOPELOG, USR_AUTOFORNE_NGD.CDARVPROD,
                       TO_DATE(SUBSTR(USR_AUTOFORNE_NGD.DTPROGENTAF, 7, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTPROGENTAF, 5, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTPROGENTAF, 1, 4), 'DD/MM/YYYY'),
                       USR_AUTOFORNE_NGD.QTPROGENTAF, USR_AUTOFORNE_NGD.VRPREUNIAF, USR_AUTOFORNE_NGD.CDFORNECED, USR_AUTOFORNE_NGD.TXOBSITMAF,
                       TO_DATE(SUBSTR(USR_AUTOFORNE_NGD.DTOPERACAO, 7, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTOPERACAO, 5, 2)||'/'||SUBSTR(USR_AUTOFORNE_NGD.DTOPERACAO, 1, 4), 'DD/MM/YYYY'),
                       USR_AUTOFORNE_NGD.DTPROGENTAF, RELACPRODOL.CDPRARVORIG, RELACPRODOL.CDPRODARVOL
                 ORDER BY USR_AUTOFORNE_NGD.CDARVPROD)
            LOOP
               V_CONTADOR   := V_CONTADOR + 1;
               V_IDPESQITEM := C_ITEMAUTF.USR_NRPEDIDO||'-'||C_ITEMAUTF.CDFILIOPELOG||'-'||C_AUTOFORNE.CDFORNECED||'-'||
                               C_ITEMAUTF.CDARVPROD||'-'||C_ITEMAUTF.DTPROGENTAF_NGD;

               BEGIN

                  IF V_CONTADOR = 1 THEN
                     /*SELECT NVL(MAX(PRODCOMP.CDOPERADOR), '000000000065')
                       INTO V_CDCOMRADOR
                       FROM PRODCOMP, PRODUTO PC, PRODUTO
                      WHERE PRODCOMP.CDPRODUTO = PC.CDPRODUTO
                        AND C_ITEMAUTF.CDPRARVORIG = PRODUTO.CDPRODUTO
                        AND PRODUTO.CDARVPROD LIKE PC.CDARVPROD || '%';*/


                     SELECT NVL(MAX(COLETAPR.CDOPERADOR), '000000000065')
                       INTO V_CDCOMRADOR
                       FROM ITEMCOLE, COLETAPR
                      WHERE ITEMCOLE.CDFILIAL    = COLETAPR.CDFILIAL
                        AND ITEMCOLE.NRCOLEPRECO = COLETAPR.NRCOLEPRECO
                        AND ITEMCOLE.CDREGIAO    = C_ITEMAUTF.CDREGIAO
                        AND ITEMCOLE.CDFORNECED  = V_CDFORNECED
                        AND C_ITEMAUTF.DTPROGENTAF BETWEEN ITEMCOLE.DTINIVALITM AND ITEMCOLE.DTFINVALITM
                        AND INSTR('_'||C_ITEMAUTF.LISTA_CDPRARVORIG||'_', ITEMCOLE.CDPRODUTO) > 0;


                     V_EMITENTE  := EMITENTE(C_AUTOFORNE.CDFILIOPELOG, C_ITEMAUTF.CDPRARVORIG, V_CDFORNECED);
                     V_CDEMPRESA := NVL(SUBSTR(V_EMITENTE, 3, 2), '08');
                     SELECT MAX(CDINSCESTA)
                       INTO V_CDINSCESTA
                       FROM INSCRESTAD
                      WHERE CDEMPRESA = V_CDEMPRESA;
                     UPDATE AUTOFORNE
                        SET CDOPERADOR   = V_CDCOMRADOR,
                            DTAUTOFORN   = C_ITEMAUTF.DTOPERACAO,
                            IDTIPOEMITAF = CASE SUBSTR(V_EMITENTE, 1, 1)
                                              WHEN '_'
                                              THEN '1'
                                              ELSE SUBSTR(V_EMITENTE, 1, 1)
                                            END,
                            CDEMPRESA    = V_CDEMPRESA
                      WHERE AUTOFORNE.CDFILDEST  = C_ITEMAUTF.CDFILIOPELOG
                        AND AUTOFORNE.CDFILLANC  = '0003'
                        AND AUTOFORNE.NRAUTOFORN = V_NRAUTOFORN;
                  END IF;

                  SELECT NVL(MIN(VRPRECUNIITM), 0), NVL(MAX(CDMARCA), '')
                    INTO V_VRPREUNIAF, V_CDMARCA
                    FROM ITEMCOLE
                   WHERE CDREGIAO   = C_ITEMAUTF.CDREGIAO
                     AND CDFORNECED = V_CDFORNECED
                     AND CDPRODUTO  = C_ITEMAUTF.CDPRARVORIG
                     AND CDMARCA    IN (SELECT CDMARCA FROM RELACPRODOL, PRODUTO WHERE RELACPRODOL.CDPRODARVOL = PRODUTO.CDPRODUTO AND PRODUTO.CDARVPROD = C_ITEMAUTF.CDARVPROD)
                     AND C_ITEMAUTF.DTPROGENTAF BETWEEN DTINIVALITM AND DTFINVALITM
                     AND NVL(VRPRECUNIITM, 0) > 0;

                  SELECT COUNT(1)
                    INTO V_CDMARCA_PADRAO
                    FROM RELACPRODOL, PRODUTO
                   WHERE RELACPRODOL.CDPRODARVOL = PRODUTO.CDPRODUTO
                     AND PRODUTO.CDARVPROD       = C_ITEMAUTF.CDARVPROD
                     AND RELACPRODOL.CDMARCA     = '00000';

                  IF ((V_VRPREUNIAF = 0) AND (V_CDMARCA_PADRAO > 0)) THEN
                     SELECT NVL(MIN(VRPRECUNIITM), 0), NVL(MAX(CDMARCA), '')
                       INTO V_VRPREUNIAF, V_CDMARCA
                       FROM ITEMCOLE
                      WHERE CDREGIAO   = C_ITEMAUTF.CDREGIAO
                        AND CDFORNECED = V_CDFORNECED
                        AND CDPRODUTO  = C_ITEMAUTF.CDPRARVORIG
                        AND C_ITEMAUTF.DTPROGENTAF BETWEEN DTINIVALITM AND DTFINVALITM
                        AND NVL(VRPRECUNIITM, 0) > 0;
                  END IF;
                  IF V_VRPREUNIAF > 0 THEN
                     INSERT
                       INTO ITEMAUTF (CDFILDEST, CDFILLANC, NRAUTOFORN, CDPRODUTO, QTPROGENTAF, VRPREUNIAF, DTPROGENTAF, CDMARCA, TXOBSITMAF)
                     SELECT C_ITEMAUTF.CDFILIOPELOG, '0003', V_NRAUTOFORN, C_ITEMAUTF.CDPRODARVOL, C_ITEMAUTF.QTPROGENTAF,
                            V_VRPREUNIAF, C_ITEMAUTF.DTPROGENTAF, V_CDMARCA, C_ITEMAUTF.TXOBSITMAF
                       FROM DUAL
                      WHERE NOT EXISTS(SELECT 1
                                         FROM ITEMAUTF I
                                        WHERE I.CDFILDEST    = C_ITEMAUTF.CDFILIOPELOG
                                          AND I.CDFILLANC    = '0003'
                                          AND I.NRAUTOFORN   = V_NRAUTOFORN
                                          AND I.CDPRODUTO    = C_ITEMAUTF.CDPRODARVOL
                                          AND I.DTPROGENTAF  = C_ITEMAUTF.DTPROGENTAF
                                          AND I.CDMARCA      = V_CDMARCA);
                     IMPOSTO_ITEMAF(V_CDEMPRESA, V_CDINSCESTA, V_CDFORNECED, C_ITEMAUTF.CDFILIOPELOG, '0003', V_NRAUTOFORN, C_ITEMAUTF.DTPROGENTAF);
                     UPDATE USR_AUTOFORNE_NGD
                        SET STATUS = '0',
                            DTINTERFACEDEST = SYSDATE
                      WHERE USR_NRPEDIDO    = C_AUTOFORNE.USR_NRPEDIDO
                        AND CDFILIOPELOG    = C_AUTOFORNE.CDFILIOPELOG
                        AND CDFORNECED      = C_AUTOFORNE.CDFORNECED
                        AND CDARVPROD       = C_ITEMAUTF.CDARVPROD
                        AND DTPROGENTAF     = C_AUTOFORNE.DTPROGENTAF_NGD;
                     UPDATE USR_LOG_NGD
                        SET DTLOG      = SYSDATE,
                            STATUS     = '0',
                            OBSSTATUS  = NULL
                      WHERE IDPROCESSO = 'USR_AUTOFORNE_NGD'
                        AND IDPESQITEM = V_IDPESQITEM;
                     IF SQL%NOTFOUND THEN
                        INSERT
                          INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                        VALUES ('USR_AUTOFORNE_NGD', SYSDATE, '0', NULL, V_IDPESQITEM);
                     END IF;
                  ELSE
                     RAISE_APPlICATION_ERROR(-20501, 'Item sem tabela de preo ou com preo igual a zero.');
                  END IF;
               EXCEPTION
                  WHEN OTHERS THEN BEGIN
                     ROLLBACK;
                     V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
                     UPDATE USR_LOG_NGD
                        SET DTLOG      = SYSDATE,
                            STATUS     = '1',
                            OBSSTATUS  = V_ERRO
                      WHERE IDPROCESSO = 'USR_AUTOFORNE_NGD'
                        AND IDPESQITEM = V_IDPESQITEM;
                     IF SQL%NOTFOUND THEN
                        INSERT
                          INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                        VALUES ('USR_AUTOFORNE_NGD', SYSDATE, '1', V_ERRO, V_IDPESQITEM);
                     END IF;
                     COMMIT;
                     EXIT;
                  END;
               END;
            END LOOP;
            /************FECHA AF E ATUALIZA TABELA INTERMEDI?RIA COM STATUS 0************/
            BEGIN
               IF V_ERRO IS NULL THEN
                  FECHA_AUTOFORNE_NGD(C_AUTOFORNE.CDFILIOPELOG, '0003', V_NRAUTOFORN);
                  UPDATE USR_AUTOFORNE_NGD
                     SET STATUS = '0',
                         DTINTERFACEDEST = SYSDATE
                   WHERE USR_NRPEDIDO    = C_AUTOFORNE.USR_NRPEDIDO
                     AND CDFILIOPELOG    = C_AUTOFORNE.CDFILIOPELOG
                     AND CDFORNECED      = V_CDFORNECED;
                  /**************ENVIAR AF PARA O PORTAL*************/
                  /*SELECT COUNT(1)
                    INTO V_CONTAAF
                    FROM AUTOFORNE
                   WHERE CDFILDEST       = C_AUTOFORNE.CDFILIOPELOG
                     AND CDFILLANC       = '0003'
                     AND NRAUTOFORN      = V_NRAUTOFORN
                     AND (NVL(IDSITUATUAAF, '0') <> '1')
                     AND (NVL(IDAFFORALIM, 'N')  <> 'S');
                  IF V_CONTAAF > 0 THEN
                     FOR C_FORNECEDOR IN (SELECT F.IDTPIJURFORN, F.NRINSJURFORN, F.CDFORNECED, F.NMFANTFORN,
                                                 F.IDUTILZIPAF, F.IDTPENVAFNORMAL, F.IDTPENVAFFOR, F.CDFORNERELACAF AS CDFORNERELAC,
                                                 ENDEFORN.CDPAIS, ENDEFORN.SGESTADO
                                            FROM FORNECEDOR F, FORNECEDOR, ENDEFORN
                                           WHERE FORNECEDOR.CDFORNECED  = V_CDFORNECED
                                             AND NVL(FORNECEDOR.CDFORNERELACAF, FORNECEDOR.CDFORNECED) = F.CDFORNECED
                                             AND FORNECEDOR.CDFORNECED = ENDEFORN.CDFORNECED
                                             AND NVL(ENDEFORN.IDTPENDEFORN, 'T') = 'P'
                                             AND NVL(F.IDTPENVAFNORMAL, 'P')     = 'P')
                     LOOP
                        SELECT NVL(MAX(NRSEQENVIOAFORN), 'W')
                          INTO V_NRSEQENVIOAFORN
                          FROM ENVIOAFFORN
                         WHERE CDFORNECED     = C_FORNECEDOR.CDFORNECED
                           AND DTENTREGAFFORN = C_AUTOFORNE.DTPROGENTAF;
                        IF V_NRSEQENVIOAFORN <> 'W' THEN
                           UPDATE ENVIOAFFORN
                              SET QTAFSENVIOFOR   = QTAFSENVIOFOR + 1
                            WHERE NRSEQENVIOAFORN = V_NRSEQENVIOAFORN;
                        ELSE
                           NOVO_CODIGO_NT('ENVIOAFFORN', V_NRSEQENVIOAFORN, 1);
                           V_NRSEQENVIOAFORN := SUBSTR(V_NRSEQENVIOAFORN, 11, 10);
                           INSERT
                             INTO ENVIOAFFORN (NRSEQENVIOAFORN, CDFORNECED, CDPAIS, SGESTADO, DTINIAPURAFFORN,
                                  DTFINAPURAFFORN, DTENVIOAFFORN, QTAFSENVIOFOR, QTAFSNENVFOR, IDTIPENVLIDO,
                                  IDTIPENVAFFORN, DSARQENVIOAF, CDOPERINCLUSAO, DTENTREGAFFORN,
                                  LISTNRSEQAPUR, IDUTILSMTP, DSEXTENSAO, IDTCLASSENVAFOR)
                           VALUES (V_NRSEQENVIOAFORN, C_FORNECEDOR.CDFORNECED, C_FORNECEDOR.CDPAIS, C_FORNECEDOR.SGESTADO, C_AUTOFORNE.DTPROGENTAF,
                                  C_AUTOFORNE.DTPROGENTAF, TO_DATE(TRUNC(SYSDATE)), 1, 0, 'N',
                                  'P', '', '000000000065', C_AUTOFORNE.DTPROGENTAF,
                                  NULL, 'S', 'PDF', 'N');
                        END IF;
                        UPDATE AUTOFORNE
                           SET IDSTATLEITURA          = 'N',
                               NRSEQENVIOAFORN        = V_NRSEQENVIOAFORN,
                               USR_NGD_INTEGRA_PORTAL = 'N';
                         WHERE CDFILDEST       = C_AUTOFORNE.CDFILIOPELOG
                           AND CDFILLANC       = '0003'
                           AND NRAUTOFORN      = V_NRAUTOFORN;
                     END LOOP;
                  END IF;*/
                  /**************FIM ENVIAR AF PARA O PORTAL*************/
                 UPDATE AUTOFORNE
                    SET IDSTATLEITURA          = 'N',
                        NRSEQENVIOAFORN        = V_NRSEQENVIOAFORN,
                        USR_NGD_INTEGRA_PORTAL = 'N'
                  WHERE CDFILDEST       = C_AUTOFORNE.CDFILIOPELOG
                    AND CDFILLANC       = '0003'
                    AND NRAUTOFORN      = V_NRAUTOFORN;
                  COMMIT;
               ELSE
                  ROLLBACK;
               END IF;
            EXCEPTION
               WHEN OTHERS THEN BEGIN
                  ROLLBACK;
                  V_ERRO := SUBSTR(SQLERRM(SQLCODE), 1, 300);
                  UPDATE USR_LOG_NGD
                     SET DTLOG      = SYSDATE,
                         STATUS     = '1',
                         OBSSTATUS  = V_ERRO
                   WHERE IDPROCESSO = 'USR_AUTOFORNE_NGD'
                     AND IDPESQITEM = V_IDPESQITEM;
                  IF SQL%NOTFOUND THEN
                     INSERT
                       INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
                     VALUES ('USR_AUTOFORNE_NGD', SYSDATE, '1', V_ERRO, V_IDPESQITEM);
                  END IF;
                  COMMIT;
               END;
            END;
            /******************************************/
            COMMIT;
         END IF;
      ELSE
         V_ERRO := 'Item sem tabela de preo ou com preo igual a zero.';
         ROLLBACK;
         UPDATE USR_LOG_NGD
            SET DTLOG      = SYSDATE,
                STATUS     = '1',
                OBSSTATUS  = V_ERRO
          WHERE IDPROCESSO = 'USR_AUTOFORNE_NGD'
            AND IDPESQITEM = V_IDPESQITEM;
         IF SQL%NOTFOUND THEN
            INSERT
              INTO USR_LOG_NGD(IDPROCESSO, DTLOG, STATUS, OBSSTATUS, IDPESQITEM)
            VALUES ('USR_AUTOFORNE_NGD', SYSDATE, '1', V_ERRO, V_IDPESQITEM);
         END IF;
         COMMIT;
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMP_AUTOFORNE_NGD','6.45.048'); END;
/
